#  				SSBA 2.0F                
#              
# Makefile : benchio.mk
#                                  
########################################################################
SHELL=/bin/sh

.PRECIOUS:	run
.IGNORE:	

PRINTER	=	lp
PRINTOPT=	-l66
PAGER	=	more
COMPILER=	cc
LOCALOPT=	-O
FLOPT=		

CFLAGS	=
CC	=	$(COMPILER) $(CFLAGS) $(LOCALOPT)

NAME	=	benchio
README	=	${NAME}.doc ${NAME}.files
MAKEFILE=	${NAME}.mk
CONFIG	=	${NAME}.cf
RUN	=	${NAME}.run
BLOC	=	100 1000 4000
TAILLEFIC =	10000000
RES	=	${NAME}.res
LOG	=	${NAME}.log
KILL	=	${NAME}.kill
JOU	=	${NAME}.jou
TAR	=	${NAME}.tar
SHAR	=	${NAME}.shar
BANNER	=	${NAME}.ban
FICHCONF=	config.done
SOURCES =	benchio.c
OBJECTS	=	benchio.o
TARGETS =	$(NAME)
SSBASIZE=	../results/ssba.size
SSBALOG =	../results/ssba.log
TRACE	=	1>>$(JOU) 2>&1
NUL	=	1>/dev/null 2>&1
ARCHIVES=	$(TAR) $(SHAR)
VOLATILE=	$(JOU) $(LOG) $(RES) $(TARGETS) $(KILL) $(ARCHIVES) $(FICHCONF)\
		$(OBJECTS) core
SCRIPTS =	$(MAKEFILE) $(CONFIG) $(RUN) faitab
FILES	=	$(BANNER) $(README) $(SCRIPTS) $(SOURCES)

conf:		
		@chmod u+x $(CONFIG)
		@./$(CONFIG)
		@touch config.done

compile:	$(TARGETS)

run:		$(FICHCONF)		
		@./$(RUN) -b "$(BLOC)" -t "$(TAILLEFIC)" $(RES)

sizes:
		@ls -l $(TARGETS) | tee -a $(SSBASIZE)
clean:
		@rm -f $(VOLATILE) $(NUL)
readme:
		@$(PAGER) $(README)
print:
		@pr $(PRINTOPT) -h $(NAME) $(SCRIPTS) | $(PRINTER)
printall:
		@pr $(PRINTOPT) -h $(NAME) $(FILES) | $(PRINTER)
tar:
		@tar cf $(TAR) $(FILES)
shar:
		@shar $(FILES) > $(SHAR)
force:

$(BANNER):
		@banner $(NAME) >$@

benchio:	$(SOURCES)
		$(CC) $(SOURCES) -o $@
