/* @(#) chrono.c  Reecriture de time(1) */
/*
 *	Programme adpate a partir du programme time_a.c de l'EUUGD5
 *
 *	Adapatble a un HZ donne (#include hz.h) :
 *		HZ = 50 ou 60 ou 100
 *	Format de sortie mieux adapte pour l'interpretaion des resultats
 *	sur stderr.
 *
 *	programme	real_time	user_time	system_time
 *
 *	Historique :	EUUG			creation
 *			Philippe Dax		modification 7/7/87
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/times.h>
#include "hz.h"
#define SIZECMD	25

main(argc, argv)
char **argv;
{
	struct tms tbuffer;
	long start, stop;
	register pid;
	int status, ret;
	char **av;
	char cmd[SIZECMD];

	if (argc == 1) {
		fprintf(stderr, "Usage: %s command\n", argv[0]);
		exit (1);
	}
	argv[argc] = 0;
	av = argv;
	cmd[0] = '\0';
	while ((strlen(cmd)<sizeof(cmd)-2) && *++av) {
		strncat(cmd, *av, sizeof(cmd)-3);
		strncat(cmd, " ", sizeof(cmd)-2);
	}
	time(&start);
	times(&tbuffer);
	switch (pid = fork()) {
	case -1:
		fprintf(stderr, "chrono: cannot fork.\n");
		exit (2);
	case 0:
		argv++;
		execvp(*argv, argv);
		sleep(1);
		fprintf(stderr, "%s: not found.\n", cmd);
		exit (3);
	default:
		while ((ret = wait(&status)) != pid && ret != -1) ;
		if ((status & 0377) != '\0')
		fprintf(stderr,"chrono: command terminated abnormally.\n");
	}
	times(&tbuffer);
	time(&stop);
	if (stop < start)
	{
	fprintf(stderr,"chrono: incoherent measure of time.\n");
	exit(5);
	}
	fprintf(stderr, "%s: \t%8.2f\t%8.2f\t%8.2f\n",
		cmd,
		(double) (stop-start),
		(double) (tbuffer.tms_cutime / (double) HZ),
		(double) (tbuffer.tms_cstime / (double) HZ)
		);
	exit (0);
}
