#include <stdio.h>
#include <fcntl.h>
#include <signal.h>

extern int srand48();
extern long time();
extern double drand48();
extern char *malloc();

int timed_out();

long badwrites, filesize, bufsize, writes, maxtime, starttime = 0;
int fd, verbose;
char *filename;

main(argc, argv)        /* random file writes */
int argc;
char *argv[];
{
        register long where, limit;
        char *buffer;

        if (argc < 5) {
          printf("Usage: %s filename filesize bufsize seconds [verbose]\n",
            argv[0]);
          exit(1);
        }
        verbose = (argc > 5);

        if ((fd = open(argv[1], O_WRONLY, 0666)) < 0)
            error_message(argv[0],"can't open file");

        filesize = howmuch(argv[2]);
        bufsize = howmuch(argv[3]);
        maxtime = howmuch(argv[4]);
        limit = filesize - bufsize;

        if ((buffer = malloc(bufsize)) == (char *)NULL)
            error_message(argv[0],"malloc failed");
        {       register int i;
                for (i=0; i<bufsize;) buffer[i++] = 'Y';
        }

        /* Write at the end to make sure there are no problems */

        writes = 0;
        badwrites = 0;
        if (srand48((long)(getpid() * getppid())) < 0 )
                error_message(argv[0],"couldn't set seed");

        signal(SIGALRM,timed_out);
        starttime = time((long *)0);
        alarm(maxtime);
        for (;;) {
                where = drand48() * limit;
                if (lseek(fd,where,0) != where) 
                        error_message(argv[0],"random seek failed");
                if (write(fd,buffer,bufsize) != bufsize) badwrites++;
                writes++;
        }
}
int timed_out()
{
        long bps, wps, stoptime;
         
        close(fd);
        stoptime = time((long *)0);
        wps = 1.0 * writes/(stoptime - starttime);
        bps = 1.0 * bufsize*writes/(stoptime - starttime);
        if (verbose) {
          printf("%ld second alarm reached\n",maxtime);
          printf("%ld timed seconds\n",stoptime - starttime);
          printf("File is %ld bytes\n",filesize);
          printf("%ld-byte buffers were written %ld times\n",bufsize,writes);
          printf("%ld writes per second\n",wps);
          printf("%ld bytes per second\n",bps);
          printf("%ld bad writes\n",badwrites);
        }
        else printf("%10ld%10ld%6ld%12ld%10ld%10ld%10ld\n",
                     filesize,bufsize,maxtime,writes,bps,wps,badwrites);
        exit(0);
}
