#include <errno.h>
#include <stdio.h>

extern long atol();
extern int errno, sys_nerr;
extern char *sys_errlist[];

void error_message(progname,message)
char *progname, *message;
{
	/* This is done to simplify output redirection from shell
	   scripts, and because I don't know the portability of perror */
	
	if (errno > sys_nerr) 
	  printf("%s: %s: errno = %d\n",progname,message,errno);
	else
	  printf("%s: %s: %s\n",progname,message,sys_errlist[errno]);
	exit(1);
}
long howmuch(target)
char *target;
{
	char *scan, copy[40];
	int kilo, meg, i;
	long temp;

	kilo = 0;
	meg = 0;
	i = 0;
	scan = target;
	while (*scan!='\0') {
		copy[i++] = *scan;
		if (*scan == 'k' || *scan == 'K') {
			copy[i] = '\0';
			kilo++;
		}
		if (*scan == 'm' || *scan == 'M') {
			copy[i] = '\0';
			meg++;
		}
		scan++;
	}
	if (kilo && meg) return 0;

	temp = atol(target);

	if (kilo) temp = temp*1024;
	if (meg)  temp = temp*1048576;
	return temp;
}
int get_pwd(pathname,size)
char *pathname;
int size;

#ifdef SysV
{
	extern char *getcwd();
	if (getcwd(pathname,size) == (char *)NULL) return(-1);
	return(0);
}
#else
{
	extern FILE *popen();
	extern int pclose();
	FILE *stream;
	if ((stream = popen("/bin/pwd","r")) == (FILE *)NULL) return(-1);
	fscanf(stream,"%s",pathname);
	pclose(stream);
	return(0);
}
#endif
