/* ioflush.c
/* Copyright (c) 1990, Prime Computer, Inc., Natick, MA 01760
/*                     All Rights Reserved
*/

/* This module ATTEMPTS to flush all dirty pages to disk and return
   the time it took to do this.  You may have to modify this for
   your specific system.

   Initial Version: 28 June 1990 by Barry Wolman
*/

#include <stdio.h>
#include <fcntl.h>
#include "ioincl.h"

extern struct control control;

long ioflush(user,sys)
double *user,*sys;
    {
    long start,finish;
    int i,fid;
    double u1,s1,u2,s2;

    time(&start);
    cptimes(&u1,&s1);
#ifdef USE_FSYNC
    for(i = 0; i < control.n_files; i++) {
         if ((fid = open(control.path[i],O_RDWR)) < 0)
              fprintf(stderr,"iobench: Could not reopen %s\n",control.path[i]);
         else {
              fsync(fid);
              close(fid);
              }
         }
#else
    sync();
    sync();
#endif
    cptimes(&u2,&s2);
    *user = u2-u1;
    *sys = s2-s1;
    time(&finish);
    return(finish-start);
    }

              
