/* unix_tod.c
/* Copyright (c) 1988, Prime Computer, Inc., Natick, MA 01760
/*                     All Rights Reserved
*/

/* Return time of day as seconds since midnight with "high" precision.
   Since only use of this routine is to time disk reads and difference
   between successive values is used, returning 0.0e0 is an acceptable
   fake. */

/* Initial Version:
          Modified: 24 September 1989 by Barry Wolman
               1. Add generic GETTIMEOFDAY check
*/

#ifdef GETTIMEOFDAY
#include <stdio.h>
#include <sys/time.h>

#define SECS_SINCE_EPOCH     504576000      /* Appoximate only */

double time_of_day()
    {
    struct timeval tp;
    long sec;
    double time;

    gettimeofday(&tp,NULL);

    sec = tp.tv_sec - SECS_SINCE_EPOCH;
    time = (double)sec + ((double)tp.tv_usec/1.0e6);
    return(time);
    }
#else

/* Dummy version of time_of_day subroutine for use on vanilla UNIX
   systems that cannot return time of day with granularity finer than
   one second.  If your UNIX system can return time of day with
   a precision of at least a millisecond, replace with appropriate
   code.  If runs are make with the dummy version, all disk reads will
   appear to take 0 time.
*/

double time_of_day()
    {
    return((double)time((long)0));
    }
#endif


