C     Standard version:
C     THIS PROGRAM IS DESIGNED TO BENCHMARK A NUMBER OF DIFFERENT
C     PROCESSORS.  IT DOES VARIOUS OPERATIONS (ARITHMETIC, IF/THEN,
C     ETC.) AND RECORDS THE SYSTEM CLOCK BEFORE AND AFTER.
C     IT IS WRITTEN IN STANDARD FORTRAN
C     TO CONVERT THIS PROGRAM TO A NEW PROCESSOR, TWO SETS OF CHANGES
C     MUST BE MADE:  (1) THE TIMER ROUTINE (TIMER) AT THE END OF THE
C     PROGRAM MUST BE MODIFIED TO CALL THE APPROPRIATE ROUTINE FOR
C     THIS SYSTEM.  (THE VERSION HERE IS FOR DEC VAX/UNIX)
C     (2) ALSO, THE OUTPUT MAY HAVE TO BE DEFINED WITH AN "OPEN" STATEMENT
C     THE OUTPUT FILE IS SIMPLY USED TO WRITE OUT THE INTERMEDIATE
C     TIMINGS, AND APPROXIMATELY 170 LINES OF OUTPUT ARE WRITTEN TO IT.
C     THAT IS THE ONLY I/O DONE BY THIS PROGRAM.
C     TO MAXIMIZE THE AMOUNT OF INFORMATION GATHERED, THIS PROGRAM
C     SHOULD BE RUN BOTH WITH AND WITHOUT COMPILER OPTIMIZATION, AND
C     AT TIMES WHEN THE MACHINE IS BOTH LIGHTLY AND HEAVILY LOADED.
      INTEGER*2 HV(10000),HTEMP(35)
      INTEGER*2 H1,H2,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10
      INTEGER*2 HARRY1(100,100),HARRY2(100,100),HV1(10000),HV2(10000)
      INTEGER*2 HARRY3(100,100)
      INTEGER*4 SLIMV(200),DLENV(200),DTV(200),TMCNT,II,JJ,I,J
      INTEGER*4 ISUM1,ISUM2,ISUM3,ISUM4,IA,IB,SLIM,NTHRU,DLEN,DLEN2
      INTEGER*4 RANDV(10000),SV(10000),DTYPE,I1,I2,I3,I4,I5,IT
      INTEGER*4 IARRY3(100,100),JJJ,IJI
      INTEGER*4 LIM1,LIM2,LIM3,LIM4,LIM5,LIM6,LIM7
      INTEGER*4 JUNK1,STYPE,SLIMX,ASIZE,AASIZE
      INTEGER*4 IARRY1(100,100),IARRY2(100,100),IV1(10000),IV2(10000)
      REAL*4 S,R1,R2,RSUM1,RSUM2,RA,RTEMP(35)
      REAL*4 RARRY1(100,100),RARRY2(100,100),RV1(10000),RV2(10000)
      REAL*4 RV(10000),RARRY3(100,100)
      REAL*4 RTIME2(200,3),SCALE,SSS,LASTM(3),LASTM1(3)
      REAL*8 DSUM1,DSUM2,DTEMP(35),DV(10000),D1,D2
      REAL*8 DARRY1(100,100),DARRY2(100,100),DV1(10000),DV2(10000)
      REAL*8 DARRY3(100,100)
      LOGICAL L1,L2,L3,L4,L5,L6,L7,L8
      LOGICAL LV1(10000),LV2(10000),LARRY1(100,100),LARRY2(100,100)
      LOGICAL LARRY3(100,100),LTEMP(35),LSUM
      EQUIVALENCE (HARRY1(1,1),HV1(1),IARRY1(1,1),IV1(1),
     1  RARRY1(1,1),RV1(1),DARRY1(1,1),DV1(1),DV(1),HV(1),RV(1))
      EQUIVALENCE (HARRY2(1,1),HV2(1),IARRY2(1,1),IV2(1),
     1  RARRY2(1,1),RV2(1),DARRY2(1,1),DV2(1),S)
      EQUIVALENCE (HARRY3(1,1),IARRY3(1,1),RARRY3(1,1),DARRY3(1,1))
      EQUIVALENCE (LV1(1),LARRY1(1,1)),(LV2(1),LARRY2(1,1))
C     DLEN - LENGTH OF DATA ITEM IN BASIC UNITS
C     DLENV(200) - RECORD OF DLEN
C     DTYPE - DATA TYPE (1=HALF WORD, 2=WORD, 3=DOUBLE WORD)
C     DTV(200) - RECORD OF DTYPE
C     FTIME - FINISH TIME FOR A TIMING INTERVAL
C     LASTM(3) - RECORDS START TIME FOR INTERVAL (LASTM2 - FOR OVERALL START)
C     LIM1...7 - LIMITS ON NUMBER OF TIMES THRU GIVEN LOOP
C     RTIME2(200,3) - RUN TIME FOR THIS TEST
C     SCALE - SCALE FACTOR - FULL RUN =1; SET TO 10 FOR 10% RUN, ETC.
C     SLIM- SORT LIMIT - NUMBER OF ELEMENTS TO SORT
C     SLIMV(200)- RECORD OF SLIM
C     TMCNT - COUNTER FOR TEST NUMBER
C     HARRYK(I,J),IARRYK(I,J),RARRYK(I,J),DARRYK(I,J), K=1...3 -
C        ARRAYS USED IN MATRIX MULT AND DIVISION
C     HVK(I),IVK(I),RVK(I),DVK(I) - SAME AS HARRY... EXCEPT
C        ONE DIMENSIONAL VERSION - AVOIDS SUBSCRIPT OPTIMIZATION
C     SV(I) - VECTOR OF NUMBERS TO BE SORTED
C     RANDV(I) - SOURCE FOR VECTOR OF NUMBERS TO BE SORTED
C     HTEMP,ITEMP,RTEMP,DTEMP - HOLDS ITEMS FOR BUBBLE SORT INTERCHANGE
C     P1...P10- PARAMETERS (HALF WORD) FOR PROCEDURE CALL TEST
C     L1...L8 - LOGICAL*1 VARIABLES FOR LOGICAL AND 1 BYTE TEST
C     INITIALIZE TIMER VARIABLES
      TMCNT=0
      DO 35 II=1,200
      DO 122 IJI=1,3
122   RTIME2(II,IJI)=0.0
      SLIMV(II)=0
      DLENV(II)=0
35    DTV(II)=0
C     INITIALIZE TIMER FOR OVERALL TIME START
      CALL TIMER(TMCNT,LASTM1,RTIME2,1)
C     INITIALIZE THE LOOP LIMITS
      SCALE=1.
      LIM1=150000/SCALE
      LIM2=300000/SCALE
      LIM3=150000/SCALE
      LIM4=35000/SCALE
      LIM5=150000/SCALE
      LIM6=250000/SCALE
      LIM7=200/SCALE
C     FILL THE ARRAY RANV WITH DATA FOR THE SORTS.  THE ARRAY WILL
C     BE FILLED WITH KEYS AGAIN WHEN NECESSARY
      II=1
      IJ=1
      DO 10 JJJ=1,2000
      J=2001-JJJ
      RANDV(J)=IJ
      IJ=IJ+IJ+1
      IF (IJ .LT. 65000) GOTO 10
      II=II+1
      IJ=II
      IF (II .LT. 1000) GOTO 10
      II=1
10    CONTINUE
C     THIS PUTS VALID VALUES IN ALL DATA ARRAYS (EQUIVALENCED)
      DO 78 I=1,10000
      DV(I)=I
78    CONTINUE
C     PUT DATA INTO LOGICAL ARRAYS
      L1=.TRUE.
      DO 96 II=1,10000
      LV1(II)=L1
      L1=.NOT. L1
96    LV2(II)=L1
      WRITE(6,101) (RANDV(J),J=1,2000)
101   FORMAT(100(20I6,/),//)
C     SLIM IS THE NUMBER OF ELEMENTS TO SORT
      SLIM=1
C     NTHRU IS THE NUMBER OF TIMES TO GO THRU THINGS
C     ADJUST FOR RUN TIME
      NTHRU=LIM1
C     VARY SLIM AND NTHRU
C     ADJUST FOR RUN TIME, NORMALLY 1...3
      DO 11 II=1,3
      NTHRU=NTHRU/25
      IF (NTHRU .LT. 1) NTHRU=1
      SLIM=SLIM*5
C     DLEN IS THE NUMBER OF ELEMENTS IN THE ARRAY ELEMENT EXCLUDING THE KEY
      DLEN2=1
C     VARY OVER RANGE 1...5 (1 TO 32 ITEMS MOVED)
      DO 13 IJ=1,6
      DLEN=DLEN2
      DLEN2=DLEN2*2
C     VARY (USING DTYPE) THE DATA TYPE AS 2, 4 BYTE INTEGERS,
C     AND 8 BYTE REALS (AND LOGICALS, 1 BYTE WHERE POSSIBLE)
      DO 17 DTYPE=1,4
C     DON'T MOVE MORE THAN 32 BYTES
      IF((IJ+DTYPE).GT.7) GOTO 17
C     FROM HERE TO THE END OF LOOP 14 IS THE BASIC ELEMENT TO TIME
C     INSERT CALL TO TIMER HERE, STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 14 IK=1,NTHRU
C     FILL THE KEY PART OF THE ARRAY
      DO 12 I=1,SLIM
12    SV(I)=RANDV(I)
      SLIMX=SLIM-1
C     THIS IS THE MAIN BUBBLE SORT LOOP
      DO 15 I=1,SLIMX
      DO 20 J=1,SLIMX
C     TEST FOR CORRECT ORDER
      IF(SV(J).LT.SV(J+1)) GOTO 19
C     COMPUTE SECOND INDEX EXPLICITLY, SO AVOID OPTIMIZATION
      JJ=J+1
C     SWAP KEYS
      IT=SV(J)
      SV(J)=SV(JJ)
      SV(JJ)=IT
C     COMPUTE ARRAY INDEXES EXPLICITLY
      IA=(J-1)*DLEN
      IB=IA+DLEN
      DO 16 K=1,DLEN
      IA=IA+1
      IB=IB+1
      GOTO (97,25,26,27),DTYPE
C     FOR LOGICAL DATA ITEMS
97    LTEMP(K)=LV1(IA)
      LV1(IA)=LV1(IB)
      LV1(IB)=LTEMP(K)
      GOTO 21
C     FOR HALF WORD INTEGER ITEMS
25    HTEMP(K)=HV(IA)
      HV(IA)=HV(IB)
      HV(IB)=HTEMP(K)
      GOTO 21
C     FOR FULL WORD REAL ITEMS
26    RTEMP(K)=RV(IA)
      RV(IA)=RV(IB)
      RV(IB)=RTEMP(K)
      GOTO 21
C     FOR DOUBLE WORD REAL ITEMS
27    DTEMP(K)=DV(IA)
      DV(IA)=DV(IB)
      DV(IB)=DTEMP(K)
21    CONTINUE
16    CONTINUE
19    CONTINUE
20    CONTINUE
15    CONTINUE
14    CONTINUE
C     INSERT END OF TIMER ROUTINE HERE
C     ETIME = TIMER CALL
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      WRITE(6,102) (SV(IX),IX=1,SLIM)
102   FORMAT(100(20I6,/))
      SLIMV(TMCNT)=SLIM
      DLENV(TMCNT)=DLEN*2**(DTYPE-1)
      DTV(TMCNT)=2**(DTYPE-1)
17    CONTINUE
13    CONTINUE
11    CONTINUE
C
C
C
C     THIS IS WHERE WE DO THE PROCEDURE CALL TEST.
C     WE CALL THREE PROCEDURES, PROC1, PROC2, AND PROC3,
C     EACH SEVERAL TIMES.
      P1=1
C     SET TIMER HERE; STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 40 J=1,LIM2
C     THIS IS A CALL ON A TEST PROCEDURE, WHICH TOUCHES ITS 1 ARGUMENT
      CALL PROC1(P1)
      WRITE(6,103) P1
103   FORMAT(I10)
40    CONTINUE
C     SET ENDTIME HERE; ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DLENV(TMCNT)=1
      P1=1
      P2=0
      P3=0
C     SET TIMER HERE; STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 41 J=1,LIM2
      CALL PROC2(P1,P2,P3)
      WRITE(6,104) P1,P2,P3
104   FORMAT(3I10)
41    CONTINUE
C     SET ENDTIME HERE; ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DLENV(TMCNT)=3
      P1=1
      P2=0
      P3=0
      P4=0
      P5=0
      P6=0
      P7=0
      P8=0
      P9=0
      P10=0
C     SET TIMER HERE; STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 42 J=1,LIM2
      CALL PROC3(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)
      WRITE(6,105) P1,P2,P3,P4,P5,P6,P7,P8,P9,P10
105   FORMAT(10I10)
42    CONTINUE
C     SET ENDTIME HERE;  ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DLENV(TMCNT)=10
C
C
C
C
C     TESTS OF INTEGER AND REAL ARITHMETIC BY USING ARRAYS - MULTIPLY
C     AND DIVIDE AND LOGICAL.
C      ASIZE IS ARRAY DIMENSION, SET ON BASIS OF LIMIT3
      AASIZE=(LIM3*1.0)**.334
      DO 48 IF=1,9
      ASIZE=AASIZE
      RA=1
C     FILL ARRAYS WITH VALID VALUES
      DO 45 I=1,100
      DO 45 J=1,100
C     JUMP TO SECTION WITH RIGHT DATA TYPE
      GOTO(91,95,92,95,93,95,94,95,95),IF
91    HARRY1(I,J)=RA
      HARRY2(I,J)=RA
      GOTO 45
92    IARRY1(I,J)=RA
      IARRY2(I,J)=RA
      GOTO 45
93    RARRY1(I,J)=RA
      RARRY2(I,J)=RA
      GOTO 45
94    DARRY1(I,J)=RA
      DARRY2(I,J)=RA
      RA=RA+1.1
45    IF (RA .GT. 70) RA=1.1
95    CONTINUE
C     SET TIMER HERE;  STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      NTHRU=1
      ASIZE=2*ASIZE
      DO 110 IJI=1,1
      ASIZE=ASIZE/2
      DO 79 III=1,NTHRU
C     BASIC MATRIX MULTIPLY LOOP
      DO 46 I=1,ASIZE
      DO 46 J=1,ASIZE
      ISUM1=0
      ISUM2=0
      ISUM3=0
      ISUM4=0
      RSUM1=0
      RSUM2=0
      DSUM1=0.0D0
      DSUM2=0.0D0
      LSUM=.TRUE.
      DO 47 K=1,ASIZE
C     SUM=SUM+ARRY1(I,K)*ARRY2(K,J)
      IA=I+(K-1)*ASIZE
      IB=K+(J-1)*ASIZE
      GOTO(51,52,53,54,55,56,57,58,98),IF
51    ISUM1=ISUM1+HV1(IA)*HV2(IB)
      GOTO 59
52    IF(HV2(IB).NE.0) ISUM2=ISUM2+HV1(IA)/HV2(IB)
      GOTO 59
53    ISUM3=ISUM3+IV1(IA)*IV2(IB)
      GOTO 59
54    IF(IV2(IB).NE.0) ISUM4=ISUM4+IV1(IA)/IV2(IB)
      GOTO 59
55    RSUM1=RSUM1+RV1(IA)*RV2(IB)
      GOTO 59
56    IF(RV2(IB) .GT. .01) RSUM2=RSUM2+RV1(IA)/RV2(IB)
      GOTO 59
57    DSUM1=DSUM1+DV1(IA)*DV2(IB)
      GOTO 59
58    IF (DV2(IB) .GT. .01D0) DSUM2=DSUM2+DV1(IA)/DV2(IB)
      GOTO 59
98    LSUM=LSUM .AND. LV1(IA) .AND. LV2(IB)
59    CONTINUE
      WRITE(6,106) ISUM1,ISUM2,ISUM3,ISUM4,RSUM1,RSUM2,DSUM1,DSUM2
106   FORMAT(4I10,4F15.5)
      GOTO (62,63,64,65,66,67,68,69,99),IF
62    HARRY3(I,J)=ISUM1
      GOTO 70
63    HARRY3(I,J)=ISUM2
      GOTO 70
64    IARRY3(I,J)=ISUM3
      GOTO 70
65    IARRY3(I,J)=ISUM4
      GOTO 70
66    RARRY3(I,J)=RSUM1
      GOTO 70
67    RARRY3(I,J)=RSUM2
      GOTO 70
68    DARRY3(I,J)=DSUM1
      GOTO 70
69    DARRY3(I,J)=DSUM2
      GOTO 70
99    LARRY3(I,J)=LSUM
70    CONTINUE
47    CONTINUE
46    CONTINUE
79    CONTINUE
C     SET TIMER HERE;  ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=IF
      DLENV(TMCNT)=ASIZE
      NTHRU=NTHRU*8
110   CONTINUE
48    CONTINUE
C
C     TEST ARITHMETIC OVERLAP HERE
      H1=1
      H2=15000
      I1=1
      I2=1500000
      R1=1.0
      R2=1500000.0
      D1=1.0D0
      D2=1500000.0D0
      SSS=2
C     SET START TIME HERE;  STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 60 I=1,LIM4
      S=H1*(H1/H2)+R1*(R1/R2)+I1*(I1/I2)+D1*(D1/D2)+R1*D1-D2/R2
     1  +I1/H2+R2/I2+H1*R1-D2*R1-I1*(1.0D0*I2)+R2/D2-H1/I2
      S=S+1
      H1=H1+1
      IF (H1 .GT. 125) H1=1
      IF (H2 .GE. 35) H2=H2-1
      I1=I1+1
      I2=I2-1
      R1=R1+1.1
      R2=R2-1.01
      D1=D1+1.1D0
      D2=D2-1.01D0
      WRITE(6,107) H1,H2,I1,I2,R1,R2,D1,D2
107   FORMAT(4I10,4F15.5)
60    CONTINUE
C     GET END TIME HERE;  ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DLENV(TMCNT)=25
C
C
C     DO COMPLICATED LOGICAL OPERATION HERE
      L1=.TRUE.
      L2=.FALSE.
      L3=.TRUE.
      L4=.FALSE.
      L5=.TRUE.
      L6=.FALSE.
      L7=.FALSE.
      L8=.TRUE.
C     SET TIMER HERE;  STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 61 I=1,LIM5
      L1=.NOT. L1
      IF (L1) L2=.NOT. L2
      IF (L1 .AND. L2) L3=.NOT. L3
      IF (L1 .AND. L2 .AND. L3) L4=.NOT. L4
      IF (L1.AND.L2.AND.L3.AND.L4) L5=.NOT.L5
      IF (L1.AND.L2.AND.L3.AND.L4.AND.L5) L6=.NOT.L6
      IF (L1.AND.L2.AND.L3.AND.L4.AND.L5.AND.L6) L7=.NOT.L7
      IF (L1.AND.L2.AND.L3.AND.L4.AND.L5.AND.L6.AND.L7) L8=.NOT.L8
      WRITE(6,108) L1,L2,L3,L4,L5,L6,L7,L8
108   FORMAT(8L5)
61    CONTINUE
C     SET END TIMER HERE;  ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DLENV(TMCNT)=1
C
C
C     THIS NEXT SECTION TESTS CONTROL STATEMENT EXECUTION
      I1=3301000
      I2=-5000000
      I3=-50
      I4=0
      I5=0
C     SET START TIMER HERE;  STIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 71 I=1,LIM6
      IF (I1 .GT. 0) GOTO 72
      I1=I1-1
72    IF (I2 .LT. 0) GOTO 73
      I2=I2+1
73    IF (I3 .NE. 0) GOTO 74
      I7=I7+1
74    I4=I4+1
      I3=I3+1
      IF(I4 .GT. 4) I4=1
      GOTO (75,76,75,76),I4
75    I5=I5+1
      GOTO 77
76    I5=I5-1
77    CONTINUE
      WRITE(6,109) I1,I2,I3,I4,I5
109   FORMAT(5I10)
71    CONTINUE
C     GET END TIMER HERE;  ETIME=
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DLENV(TMCNT)=30
C
C
C
C     THIS SECTION TESTS PURE DATA MOVEMENT
C     FIRST RUN IS WITH LOGICAL VARIABLES
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 112 I=1,LIM7
      DO 113 J=1,10000
      LV1(J)=LV2(J)
113   CONTINUE
112   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=1
C     NOW, DO IT AGAIN, WITHOUT POSSIBILITY OF STRING MOVE
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 114 I=1,LIM7
      DO 114 J=1,10000
      LV1(J)=LV2(J).AND.LV1(J)
114   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=1
C     DO IT FOR HALF WORD VALUES
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 115 I=1,LIM7
      DO 115 J=1,10000
      HV1(J)=HV2(J)
115   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DO 125 I=1,10000
      HV1(I)=1
125   HV2(I)=2
      DTV(TMCNT)=2
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 116 I=1,LIM7
      DO 116 J=1,10000
      HV1(J)=HV1(J)+HV2(J)
116   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=2
C     FOR FULL WORD VALUES -INTEGERS
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 117 I=1,LIM7
      DO 117 J=1,10000
      IV1(J)=IV2(J)
117   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DO 126 I=1,10000
      IV1(I)=I
126   IV2(I)=I+1
      DTV(TMCNT)=4
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 118 I=1,LIM7
      DO 118 J=1,10000
      IV1(J)=IV2(J)+IV1(J)
118   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=4
C     DO DOUBLE WORD MOVES, USING REAL*8
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 119 I=1,LIM7
      DO 119 J=1,10000
      DV1(J)=DV2(J)
119   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=8
      DO 130 I=1,10000
      DV1(I)=I+1.0
      DV2(I)=I-1.0
130   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,1)
      DO 120 I=1,LIM7
      DO 120 J=1,10000
      DV1(J)=DV1(J)+DV2(J)
120   CONTINUE
      CALL TIMER(TMCNT,LASTM,RTIME2,2)
      DTV(TMCNT)=8
C
C
C
C
C     CALL TIMER FOR FINAL TIME
      CALL TIMER(TMCNT,LASTM1,RTIME2,2)
C     WRITE OUT SCALING FACTOR, RUN INFO, AND THEN RUN TIMES
      DO 80 I=1,TMCNT
      WRITE(6,81) SCALE,I,SLIMV(I),DLENV(I),DTV(I),(RTIME2(I,II),II=1,3)
81    FORMAT('smith: ',F3.1,4I5,3F15.2)
80    CONTINUE
      STOP
      END
C
C
C
C     SUBROUTINES FOR TESTING PROCEDURE CALL.
      SUBROUTINE PROC1(P1)
      INTEGER*2 P1
      P1=-P1
      RETURN
      END
C
C
C
C
C
      SUBROUTINE PROC2(P1,P2,P3)
      INTEGER*2 P1,P2,P3,P
      P=P1
      P1=P2
      P2=P3
      P3=-P
      RETURN
      END
C
C
C
C
C
      SUBROUTINE PROC3(P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)
      INTEGER*2  P,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10
      P=P1
      P1=P2
      P2=P3
      P3=P4
      P4=P5
      P5=P6
      P6=P7
      P7=P8
      P8=P9
      P9=P10
      P10=-P
      RETURN
      END


      SUBROUTINE TIMER(TMCNT,LASTM,RTIME2,SE)
      INTEGER*4 TMCNT,SE
      REAL*4 LASTM(3),RTIME2(200,3),TARRAY(2),T1
C     ETIME IS THE TIMER FUNCTION.  IT RETURNS BOTH A VALUE
C     AND A TWO ELEMENT ARRAY;  THE RETURN VALUE IS THE TIME
C     USED SO FAR, AND THE TWO ELEMENTS IN THE ARRAY ARE THE SAME
C     DATA, BROKEN DOWN BY USER AND SYSTEM TIME.
      T1=ETIME(TARRAY)
C     IF SE >=2, THEN THIS IS END OF INTERVAL; RECORD ELAPSED TIME
      IF(SE .GE. 2) GOTO 10
C     RECORD TIME AT BEGINNING OF INTERVAL
      LASTM(1)=T1
      LASTM(2)=TARRAY(1)
      LASTM(3)=TARRAY(2)
      RETURN
C     THIS IS END OF INTERVAL; RECORD ELAPSED TIME
10    TMCNT=TMCNT+1
      RTIME2(TMCNT,1)=T1-LASTM(1)
      RTIME2(TMCNT,2)=TARRAY(1)-LASTM(2)
      RTIME2(TMCNT,3)=TARRAY(2)-LASTM(3)
      WRITE(6,11) TMCNT,(RTIME2(TMCNT,J),J=1,3)
11    FORMAT(I10,3F15.5)
      RETURN
      END










