/* 
 * memorycopy.c --
 *
 *	Benchmark program to measure memory bandwidth.
 *	Invoke with no arguments.  It will make repeated
 *	calls to memcpy with different size buffers and
 *	print memory bandwidth as a function of buffer
 *	size.
 *	
 *
 * Copyright 1989 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */

#include <stdio.h>

/*
 * Different amounts to copy at once:
 */

int sizes[] =
	{10, 50, 100, 500, 1000, 5000, 10000, 50000, 100000, 200000, -1};

#define MAX_AT_ONCE 500000
char src[MAX_AT_ONCE], dst[MAX_AT_ONCE];

main(argc, argv)
    int argc;
    char **argv;
{
    register int *sizePtr;
    int totalBytes, bytesSoFar, count, ntotal;

    if (argc > 1) {
	totalBytes = 1000000*atoi(argv[1]);
    } else {
	totalBytes = 5000000;
    }
    ntotal = 0;
    for (sizePtr = sizes; *sizePtr > 0; sizePtr++) {
	for (bytesSoFar = 0; bytesSoFar < totalBytes;
		bytesSoFar += count) {
	    count = totalBytes - bytesSoFar;
	    if (count > *sizePtr) {
		count = *sizePtr;
	    }
	    memcpy(dst, src, count);
	}
	ntotal += totalBytes;
    }
	printf("%d\n", ntotal);
}
