/* 
 * spread.c --
 *
 *	This program is a stand-alone benchmark to measure
 *	the speed of reading a file.  It should be invoked
 *	as follows:
 *
 *	spread [count]
 *
 *	The program will read its standard input file count
 *	times from start to finish, then print out the speed
 *	of reading in bytes/sec.  If omitted, count defaults
 *	to 1.
 *
 * Copyright 1989 Regents of the University of California.
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 */


#include <stdio.h>

static char buffer[16384];

main(argc, argv)
int argc;
char **argv;
{
    int cnt, total, repeats, i;
    double Total;

    if (argc == 1) {
	repeats = 1;
    } else {
	repeats = atoi(argv[1]);
    }
    total = 0;
    Total = 0;

    for (i = 0; i<repeats; i++) {
	lseek(0, 0, 0);
	while (1) {
	    cnt = read(0, buffer, 16384);
	    total += cnt;
	    if (cnt < 16384) break;
	}
	Total += total;
    }
    printf("%.0f\n", Total);
}
