#				SSBA 2.0F
#
# Makefile : ssba.mk
#
#############################################################################
SHELL=/bin/sh

.PRECIOUS:	conf
.PRECIOUS:	run
.IGNORE:	

PRINTER	=	lp
PRINTOPT=	-l66
PAGER	=	more

#
#	Fichiers
#
NAME	=	ssba
README	=	${NAME}.doc ${NAME}.files
MAKEFILE=	${NAME}.mk
RUN	=	${NAME}.run
CONFIG	=	${NAME}.cf
TAR	=	${NAME}.tar
RES	=	${NAME}.res
KILL	=	${NAME}.kill
SHAR	=	${NAME}.shar
BANNER	=	${NAME}.ban
PROCESS	=	${NAME}.ps
SIZE	=	${NAME}.size
SYNTHESE=	${NAME}.syn
TEMPS	=	${NAME}.time
DONE	=	conf.done compile.done
NUL	=	1>/dev/null 2>&1
ARCHIVES=	$(TAR) $(SHAR)
VOLATILE=	$(ARCHIVES) $(DONE) $(KILL) core
SCRIPTS	=	Makefile ${NAME}.mk ${NAME}.run ${NAME}.def ${NAME}.ini\
		${NAME}.bgr ${NAME}.cf ${NAME}.rerun unix.sh ${NAME}.ps\
		../fiche ssbakill ${NAME}.syn ${NAME}.size size1.awk size2.awk\
		date.awk ${NAME}.time stan.test
FILES	=	$(BANNER) $(README) $(SCRIPTS)

readme:
		@$(PAGER) $(README)
conf:
		@./$(CONFIG)
run:
		@./$(RUN)
clean:
		@rm -f $(VOLATILE) $(NUL)
readme:
		@$(PAGER) $(README)
print:
		@pr $(PRINTOPT) -h $(NAME) $(SCRIPTS) | $(PRINTER)
printall:
		@pr $(PRINTOPT) -h $(NAME) $(FILES) | $(PRINTER)
tar:
		@tar cf $(TAR) $(FILES)
shar:
		@shar $(FILES) > $(SHAR)
force:
