#				SSBA 2.0F
#
# Makefile : testc.mk
#
##############################################################################
SHELL=/bin/sh

.PRECIOUS:	run
.IGNORE:	

PRINTER	=	lp
PRINTOPT=	-l66
PAGER	=	more
COMPILER=	cc
CC	=	$(COMPILER)

NAME	=	testc
README	=	${NAME}.doc ${NAME}.files
MAKEFILE=	${NAME}.mk
CONFIG	=	${NAME}.cf
RUN	=	${NAME}.run
JOU	=	${NAME}.jou
LOG	=	${NAME}.log
KILL	=	${NAME}.kill
RES	=	${NAME}.res
TAR	=	${NAME}.tar
SHAR 	=	${NAME}.shar
BANNER 	=	${NAME}.ban
HEADERS	=	${NAME}1.h ${NAME}2.h ${NAME}3.h
SOURCES	=	${NAME}.c
OBJECTS	=	${NAME}.o
TARGETS	=	${NAME}.o
SSBALOG	=	../results/ssba.log
SSBASIZE=	../results/ssba.size
TRACE	=	1>>$(JOU) 2>&1
NUL	=	1>/dev/null 2>&1
ARCHIVES=	$(TAR) $(SHAR)
VOLATILE=	$(JOU) $(LOG) $(RES) $(KILL) $(OBJECTS) $(TARGETS)\
		$(ARCHIVES) core verif
SCRIPTS =	$(MAKEFILE) $(CONFIG) $(RUN)
FILES	=	$(BANNER) $(README) $(SCRIPTS) $(SOURCES) $(HEADERS)

conf:
		@chmod u+x $(CONFIG)
		@./$(CONFIG)
run:		
		@./$(RUN)
sizes:
		@ls -l $(TARGETS) | tee -a $(SSBASIZE)
clean:
		@rm -f $(VOLATILE) $(NUL)
readme:
		@$(PAGER) $(README)
print:
		@pr $(PRINTOPT) -h $(NAME) $(SCRIPTS) | $(PRINTER)
printall:
		@pr $(PRINTOPT) -h $(NAME) $(FILES) | $(PRINTER)
tar:
		@tar cf $(TAR) $(FILES)
shar:
		@shar $(FILES) > $(SHAR)
force:

$(BANNER):
		@banner $(NAME) >$@

$(OBJECTS):	$(SOURCES) $(HEADERS) force
		$(CC) -c $(SOURCES) $(TRACE)
