typedef struct GKS_TESTS {
	Gchar	*tests;		/* name of test (for menu choice) */
	int	(*funcs)();	/* pointer to test function */
	Gchar	usr_input;	/* does test require user interaction? */
	Gchar	outTest;	/* can this test run on Output ws? */
	Gchar	inputTest;	/* can this test run on Input ws? */
	Gchar	outinTest;	/* can this test run on OutIn ws? */
	Gchar	miTest;		/* can this test run on Metafile Input ws? */
	Gchar	moTest;		/* can this test run on Metafile Output ws? */
	Gchar	wissTest;	/* can this test run on WISS ws? */
} GKSTestProgs;

typedef struct {
	Gfile	*fp;			/* output file pointer */
	Gint	wkstid;			/* workstation id */
	Gwstype	*wsType;		/* workstation type */
	Gconn 	*connId;		/* workstation connection id */
	Gchar	pause;			/* pause between tests */
	Gint	err_ctr;		/* error counter */
} ArteG_C_Test;

typedef struct {
	Gint	colour;			/* text color index */
	Gfloat	height;			/* character height */
	Gpoint	up;			/* character up vector */
	Gfloat	expansion;		/* character expansion factor */
	Gfloat	spacing;		/* character spacing */
	Gtxpath	path;			/* text path */
	Gtxalign align;			/* text alignment */
	Gtxfp	fp;			/* text font and precision */
} TEXTATTR;

typedef struct {
	Gfloat	ext[4][2];		/* text extent rectangle */
	Gint	color;			/* extent rectangle line color */
	Gint	linetype;		/* extent rectangle linetype */
	Gfloat	linewidth;		/* extent rectangle linewidth */
} TEXTEXT;

typedef struct {
	Gpoint	pt;			/* text origin coordinate */
	Gint	color;			/* origin marker color */
	Gint	type;			/* origin marker type */
	Gfloat	size;			/* origin marker size */
} TEXTORG;

typedef struct {
	Gpoint	pt;			/* text concatentation coordinate */
	Gint	color;			/* concatentation marker color */
	Gint	type;			/* concatentation marker type */
	Gfloat	size;			/* concatentation marker size */
} TEXTCAT;

typedef struct {
	Gfloat	ext[2][2];		/* baseline/centreline end points */
	Gint	color;			/* line color */
	Gint	linetype;		/* linetype */
	Gfloat	linewidth;		/* linewidth */
} BASLINE;
