/*********************************************************************
*
* Name        : localtiming.c
*
* Version     : 1.1
*
* Description : Common Standard Portable Timing Routine.
*
* Modified by : Aju John
*
* e-mail      : mach@cs.wpi.edu
*
* Address     : Mach Research Group
*               Worcester Polytechnic Institute
*               Computer Science Department
*               100 Institute Road,
*               Worcester MA 01609.
*               U.S.A
*               (508) 831-5357
*                 
************************************************************************/

#include <sys/types.h>
#include <sys/stat.h>

local_timing()

{

unsigned long return_value;

#ifdef VMUNIX
#include <sys/time.h>
  struct timeval  lc_gtime_start;
  struct timezone lc_gt_zp;
  unsigned long   lc_gtime_elapsed;
  gettimeofday (&lc_gtime_start, &lc_gt_zp);
  lc_gtime_elapsed = (1000.0*lc_gtime_start.tv_sec + lc_gtime_start.tv_usec/1000.0);
  return_value =  lc_gtime_elapsed ;
  return (return_value);
#endif

#ifdef SysV
#include <sys/times.h>
#include "../install/hz.h"
  struct tms    lc_times_start;
  unsigned long   lc_times_stime,  lc_times_utime;
  times(&lc_times_start);
  lc_times_utime = 1000*(lc_times_start.tms_utime)/HZ;
  lc_times_stime = 1000*(lc_times_start.tms_stime)/HZ;
  return_value = lc_times_utime + lc_times_stime;
  return (return_value);
#endif 

}
